Skip to main content

WebSocket API

HeliOS exposes a WebSocket endpoint at /v1/ws.

  • WebSocket URL: ws(s)://<host>/v1/ws
  • AsyncAPI: GET /asyncapi.json (or GET /v1/asyncapi.json)

Channels

ChannelSummaryMessages
console.sessionInteractive consoleconsole_session, console_session_response_0
device.telemetryDevice telemetrydevice_telemetry, device_telemetry_response_0
devices.updatesPeripheral + stream inventory changesdevices_updates, devices_updates_response_0
imu.streamIMU status streamimu_stream, imu_stream_response_0
logs.streamDevice logslogs_stream, logs_stream_response_0
ota.streamOTA update status streamota_stream, ota_stream_response_0
processes.streamPer-process resource usageprocesses_stream, processes_stream_response_0
sensors.streamPeripheral sensor streamsensors_stream, sensors_stream_response_0
streams.{stream_id}.framesStream framesstreams__stream_id__frames
streams.{stream_id}.metricsStream metricsstreams__stream_id__metrics, streams__stream_id__metrics_response_0, streams__stream_id__metrics_response_1
updates.streamGlobal realtime change streamupdates_stream, updates_stream_response_0

Message Details

console.session

console_session

  • Summary: Interactive console
  • Description: PTY-backed interactive shell session (supports persistent sessions via sessionId).

console_session_response_0

  • Summary: Interactive console
  • Description: PTY-backed interactive shell session (supports persistent sessions via sessionId).

device.telemetry

device_telemetry

  • Summary: Device telemetry
  • Description: Realtime CPU/memory/disk telemetry for the device.

device_telemetry_response_0

  • Summary: Device telemetry
  • Description: Realtime CPU/memory/disk telemetry for the device.

devices.updates

devices_updates

  • Summary: Peripheral + stream inventory changes
  • Description: Notifies clients when USB peripherals or registered streams change.

devices_updates_response_0

  • Summary: Peripheral + stream inventory changes
  • Description: Notifies clients when USB peripherals or registered streams change.

imu.stream

imu_stream

  • Summary: IMU status stream
  • Description: Streams realtime IMU status payloads from the device IMU runtime.

imu_stream_response_0

  • Summary: IMU status stream
  • Description: Streams realtime IMU status payloads from the device IMU runtime.

logs.stream

logs_stream

  • Summary: Device logs
  • Description: Stream of log lines from the device.

logs_stream_response_0

  • Summary: Device logs
  • Description: Stream of log lines from the device.

ota.stream

ota_stream

  • Summary: OTA update status stream
  • Description: Streams OTA updater state snapshots and progress events.

ota_stream_response_0

  • Summary: OTA update status stream
  • Description: Streams OTA updater state snapshots and progress events.

processes.stream

processes_stream

  • Summary: Per-process resource usage
  • Description: Periodic snapshots of CPU and memory usage per process.

processes_stream_response_0

  • Summary: Per-process resource usage
  • Description: Periodic snapshots of CPU and memory usage per process.

sensors.stream

sensors_stream

  • Summary: Peripheral sensor stream
  • Description: Streams subscribed IMU, power, lighting, and firmware sensor events from the peripherals runtime.

sensors_stream_response_0

  • Summary: Peripheral sensor stream
  • Description: Streams subscribed IMU, power, lighting, and firmware sensor events from the peripherals runtime.

streams.{stream_id}.frames

streams__stream_id__frames

  • Summary: Stream frames
  • Description: Binary encoded frames for the currently active pipeline output (optionally switched for the socket duration).

streams.{stream_id}.metrics

streams__stream_id__metrics

  • Summary: Stream metrics
  • Description: Periodic metrics snapshots for an active stream.

streams__stream_id__metrics_response_0

  • Summary: Stream metrics
  • Description: Periodic metrics snapshots for an active stream.

streams__stream_id__metrics_response_1

  • Summary: Stream metrics
  • Description: Periodic metrics snapshots for an active stream.

updates.stream

updates_stream

  • Summary: Global realtime change stream
  • Description: Streams mutating API/WS changes for streams, pipelines, localization, media, and device settings.

updates_stream_response_0

  • Summary: Global realtime change stream
  • Description: Streams mutating API/WS changes for streams, pipelines, localization, media, and device settings.